Index: lemon/bits/graph_adaptor_extender.h
===================================================================
--- lemon/bits/graph_adaptor_extender.h	(revision 1337)
+++ lemon/bits/graph_adaptor_extender.h	(revision 664)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -86,7 +86,4 @@
     };
 
-    LemonRangeWrapper1<NodeIt, Adaptor> nodes() const {
-      return LemonRangeWrapper1<NodeIt, Adaptor>(*this);
-    }
 
     class ArcIt : public Arc {
@@ -111,8 +108,4 @@
 
     };
-
-    LemonRangeWrapper1<ArcIt, Adaptor> arcs() const {
-      return LemonRangeWrapper1<ArcIt, Adaptor>(*this);
-    }
 
 
@@ -140,8 +133,4 @@
     };
 
-    LemonRangeWrapper2<OutArcIt, Adaptor, Node> outArcs(const Node& u) const {
-      return LemonRangeWrapper2<OutArcIt, Adaptor, Node>(*this, u);
-    }
-
 
     class InArcIt : public Arc {
@@ -168,8 +157,4 @@
     };
 
-    LemonRangeWrapper2<InArcIt, Adaptor, Node> inArcs(const Node& u) const {
-      return LemonRangeWrapper2<InArcIt, Adaptor, Node>(*this, u);
-    }
-
     Node baseNode(const OutArcIt &e) const {
       return Parent::source(e);
@@ -196,6 +181,4 @@
     typedef _Graph Graph;
     typedef GraphAdaptorExtender Adaptor;
-
-    typedef True UndirectedTag;
 
     typedef typename Parent::Node Node;
@@ -270,8 +253,4 @@
     };
 
-    LemonRangeWrapper1<NodeIt, Adaptor> nodes() const {
-      return LemonRangeWrapper1<NodeIt, Adaptor>(*this);
-    }
-
 
     class ArcIt : public Arc {
@@ -296,8 +275,4 @@
 
     };
-
-    LemonRangeWrapper1<ArcIt, Adaptor> arcs() const {
-      return LemonRangeWrapper1<ArcIt, Adaptor>(*this);
-    }
 
 
@@ -325,8 +300,4 @@
     };
 
-    LemonRangeWrapper2<OutArcIt, Adaptor, Node> outArcs(const Node& u) const {
-      return LemonRangeWrapper2<OutArcIt, Adaptor, Node>(*this, u);
-    }
-
 
     class InArcIt : public Arc {
@@ -353,8 +324,4 @@
     };
 
-    LemonRangeWrapper2<InArcIt, Adaptor, Node> inArcs(const Node& u) const {
-      return LemonRangeWrapper2<InArcIt, Adaptor, Node>(*this, u);
-    }
-
     class EdgeIt : public Parent::Edge {
       const Adaptor* _adaptor;
@@ -378,9 +345,4 @@
 
     };
-
-    LemonRangeWrapper1<EdgeIt, Adaptor> edges() const {
-      return LemonRangeWrapper1<EdgeIt, Adaptor>(*this);
-    }
-
 
     class IncEdgeIt : public Edge {
@@ -409,9 +371,4 @@
     };
 
-    LemonRangeWrapper2<IncEdgeIt, Adaptor, Node> incEdges(const Node& u) const {
-      return LemonRangeWrapper2<IncEdgeIt, Adaptor, Node>(*this, u);
-    }
-
-
     Node baseNode(const OutArcIt &a) const {
       return Parent::source(a);
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 1336)
+++ lemon/bits/graph_extender.h	(revision 825)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -28,6 +28,4 @@
 #include <lemon/concepts/maps.h>
 
-#include <lemon/bits/stl_iterators.h>
-
 //\ingroup graphbits
 //\file
@@ -119,8 +117,4 @@
     };
 
-    LemonRangeWrapper1<NodeIt, Digraph> nodes() const {
-      return LemonRangeWrapper1<NodeIt, Digraph>(*this);
-    }
-
 
     class ArcIt : public Arc {
@@ -145,8 +139,4 @@
 
     };
-
-    LemonRangeWrapper1<ArcIt, Digraph> arcs() const {
-      return LemonRangeWrapper1<ArcIt, Digraph>(*this);
-    }
 
 
@@ -174,8 +164,4 @@
     };
 
-    LemonRangeWrapper2<OutArcIt, Digraph, Node> outArcs(const Node& u) const {
-      return LemonRangeWrapper2<OutArcIt, Digraph, Node>(*this, u);
-    }
-
 
     class InArcIt : public Arc {
@@ -201,8 +187,4 @@
 
     };
-
-    LemonRangeWrapper2<InArcIt, Digraph, Node> inArcs(const Node& u) const {
-      return LemonRangeWrapper2<InArcIt, Digraph, Node>(*this, u);
-    }
 
     // \brief Base node of the iterator
@@ -455,8 +437,4 @@
     };
 
-    LemonRangeWrapper1<NodeIt, Graph> nodes() const {
-      return LemonRangeWrapper1<NodeIt, Graph>(*this);
-    }
-
 
     class ArcIt : public Arc {
@@ -481,8 +459,4 @@
 
     };
-
-    LemonRangeWrapper1<ArcIt, Graph> arcs() const {
-      return LemonRangeWrapper1<ArcIt, Graph>(*this);
-    }
 
 
@@ -510,8 +484,4 @@
     };
 
-    LemonRangeWrapper2<OutArcIt, Graph, Node> outArcs(const Node& u) const {
-      return LemonRangeWrapper2<OutArcIt, Graph, Node>(*this, u);
-    }
-
 
     class InArcIt : public Arc {
@@ -538,8 +508,4 @@
     };
 
-    LemonRangeWrapper2<InArcIt, Graph, Node> inArcs(const Node& u) const {
-      return LemonRangeWrapper2<InArcIt, Graph, Node>(*this, u);
-    }
-
 
     class EdgeIt : public Parent::Edge {
@@ -564,9 +530,4 @@
 
     };
-
-    LemonRangeWrapper1<EdgeIt, Graph> edges() const {
-      return LemonRangeWrapper1<EdgeIt, Graph>(*this);
-    }
-
 
     class IncEdgeIt : public Parent::Edge {
@@ -595,9 +556,4 @@
     };
 
-    LemonRangeWrapper2<IncEdgeIt, Graph, Node> incEdges(const Node& u) const {
-      return LemonRangeWrapper2<IncEdgeIt, Graph, Node>(*this, u);
-    }
-
-
     // \brief Base node of the iterator
     //
@@ -632,5 +588,5 @@
     // Returns the base node of the iterator
     Node baseNode(const IncEdgeIt &edge) const {
-      return edge._direction ? this->u(edge) : this->v(edge);
+      return edge._direction ? u(edge) : v(edge);
     }
     // Running node of the iterator
@@ -638,5 +594,5 @@
     // Returns the running node of the iterator
     Node runningNode(const IncEdgeIt &edge) const {
-      return edge._direction ? this->v(edge) : this->u(edge);
+      return edge._direction ? v(edge) : u(edge);
     }
 
@@ -791,622 +747,4 @@
   };
 
-  // \ingroup _graphbits
-  //
-  // \brief Extender for the BpGraphs
-  template <typename Base>
-  class BpGraphExtender : public Base {
-    typedef Base Parent;
-
-  public:
-
-    typedef BpGraphExtender BpGraph;
-
-    typedef True UndirectedTag;
-
-    typedef typename Parent::Node Node;
-    typedef typename Parent::RedNode RedNode;
-    typedef typename Parent::BlueNode BlueNode;
-    typedef typename Parent::Arc Arc;
-    typedef typename Parent::Edge Edge;
-
-    // BpGraph extension
-
-    using Parent::first;
-    using Parent::next;
-    using Parent::id;
-
-    int maxId(Node) const {
-      return Parent::maxNodeId();
-    }
-
-    int maxId(RedNode) const {
-      return Parent::maxRedId();
-    }
-
-    int maxId(BlueNode) const {
-      return Parent::maxBlueId();
-    }
-
-    int maxId(Arc) const {
-      return Parent::maxArcId();
-    }
-
-    int maxId(Edge) const {
-      return Parent::maxEdgeId();
-    }
-
-    static Node fromId(int id, Node) {
-      return Parent::nodeFromId(id);
-    }
-
-    static Arc fromId(int id, Arc) {
-      return Parent::arcFromId(id);
-    }
-
-    static Edge fromId(int id, Edge) {
-      return Parent::edgeFromId(id);
-    }
-
-    Node u(Edge e) const { return this->redNode(e); }
-    Node v(Edge e) const { return this->blueNode(e); }
-
-    Node oppositeNode(const Node &n, const Edge &e) const {
-      if( n == u(e))
-        return v(e);
-      else if( n == v(e))
-        return u(e);
-      else
-        return INVALID;
-    }
-
-    Arc oppositeArc(const Arc &arc) const {
-      return Parent::direct(arc, !Parent::direction(arc));
-    }
-
-    using Parent::direct;
-    Arc direct(const Edge &edge, const Node &node) const {
-      return Parent::direct(edge, Parent::redNode(edge) == node);
-    }
-
-    RedNode asRedNode(const Node& node) const {
-      if (node == INVALID || Parent::blue(node)) {
-        return INVALID;
-      } else {
-        return Parent::asRedNodeUnsafe(node);
-      }
-    }
-
-    BlueNode asBlueNode(const Node& node) const {
-      if (node == INVALID || Parent::red(node)) {
-        return INVALID;
-      } else {
-        return Parent::asBlueNodeUnsafe(node);
-      }
-    }
-
-    // Alterable extension
-
-    typedef AlterationNotifier<BpGraphExtender, Node> NodeNotifier;
-    typedef AlterationNotifier<BpGraphExtender, RedNode> RedNodeNotifier;
-    typedef AlterationNotifier<BpGraphExtender, BlueNode> BlueNodeNotifier;
-    typedef AlterationNotifier<BpGraphExtender, Arc> ArcNotifier;
-    typedef AlterationNotifier<BpGraphExtender, Edge> EdgeNotifier;
-
-
-  protected:
-
-    mutable NodeNotifier node_notifier;
-    mutable RedNodeNotifier red_node_notifier;
-    mutable BlueNodeNotifier blue_node_notifier;
-    mutable ArcNotifier arc_notifier;
-    mutable EdgeNotifier edge_notifier;
-
-  public:
-
-    NodeNotifier& notifier(Node) const {
-      return node_notifier;
-    }
-
-    RedNodeNotifier& notifier(RedNode) const {
-      return red_node_notifier;
-    }
-
-    BlueNodeNotifier& notifier(BlueNode) const {
-      return blue_node_notifier;
-    }
-
-    ArcNotifier& notifier(Arc) const {
-      return arc_notifier;
-    }
-
-    EdgeNotifier& notifier(Edge) const {
-      return edge_notifier;
-    }
-
-
-
-    class NodeIt : public Node {
-      const BpGraph* _graph;
-    public:
-
-      NodeIt() {}
-
-      NodeIt(Invalid i) : Node(i) { }
-
-      explicit NodeIt(const BpGraph& graph) : _graph(&graph) {
-        _graph->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const BpGraph& graph, const Node& node)
-        : Node(node), _graph(&graph) {}
-
-      NodeIt& operator++() {
-        _graph->next(*this);
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper1<NodeIt, BpGraph> nodes() const {
-      return LemonRangeWrapper1<NodeIt, BpGraph>(*this);
-    }
-
-
-    class RedNodeIt : public RedNode {
-      const BpGraph* _graph;
-    public:
-
-      RedNodeIt() {}
-
-      RedNodeIt(Invalid i) : RedNode(i) { }
-
-      explicit RedNodeIt(const BpGraph& graph) : _graph(&graph) {
-        _graph->first(static_cast<RedNode&>(*this));
-      }
-
-      RedNodeIt(const BpGraph& graph, const RedNode& node)
-        : RedNode(node), _graph(&graph) {}
-
-      RedNodeIt& operator++() {
-        _graph->next(static_cast<RedNode&>(*this));
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper1<RedNodeIt, BpGraph> redNodes() const {
-      return LemonRangeWrapper1<RedNodeIt, BpGraph>(*this);
-    }
-
-
-    class BlueNodeIt : public BlueNode {
-      const BpGraph* _graph;
-    public:
-
-      BlueNodeIt() {}
-
-      BlueNodeIt(Invalid i) : BlueNode(i) { }
-
-      explicit BlueNodeIt(const BpGraph& graph) : _graph(&graph) {
-        _graph->first(static_cast<BlueNode&>(*this));
-      }
-
-      BlueNodeIt(const BpGraph& graph, const BlueNode& node)
-        : BlueNode(node), _graph(&graph) {}
-
-      BlueNodeIt& operator++() {
-        _graph->next(static_cast<BlueNode&>(*this));
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper1<BlueNodeIt, BpGraph> blueNodes() const {
-      return LemonRangeWrapper1<BlueNodeIt, BpGraph>(*this);
-    }
-
-
-
-    class ArcIt : public Arc {
-      const BpGraph* _graph;
-    public:
-
-      ArcIt() { }
-
-      ArcIt(Invalid i) : Arc(i) { }
-
-      explicit ArcIt(const BpGraph& graph) : _graph(&graph) {
-        _graph->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const BpGraph& graph, const Arc& arc) :
-        Arc(arc), _graph(&graph) { }
-
-      ArcIt& operator++() {
-        _graph->next(*this);
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper1<ArcIt, BpGraph> arcs() const {
-      return LemonRangeWrapper1<ArcIt, BpGraph>(*this);
-    }
-
-
-    class OutArcIt : public Arc {
-      const BpGraph* _graph;
-    public:
-
-      OutArcIt() { }
-
-      OutArcIt(Invalid i) : Arc(i) { }
-
-      OutArcIt(const BpGraph& graph, const Node& node)
-        : _graph(&graph) {
-        _graph->firstOut(*this, node);
-      }
-
-      OutArcIt(const BpGraph& graph, const Arc& arc)
-        : Arc(arc), _graph(&graph) {}
-
-      OutArcIt& operator++() {
-        _graph->nextOut(*this);
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper2<OutArcIt, BpGraph, Node> outArcs(const Node& u) const {
-      return LemonRangeWrapper2<OutArcIt, BpGraph, Node>(*this, u);
-    }
-
-
-    class InArcIt : public Arc {
-      const BpGraph* _graph;
-    public:
-
-      InArcIt() { }
-
-      InArcIt(Invalid i) : Arc(i) { }
-
-      InArcIt(const BpGraph& graph, const Node& node)
-        : _graph(&graph) {
-        _graph->firstIn(*this, node);
-      }
-
-      InArcIt(const BpGraph& graph, const Arc& arc) :
-        Arc(arc), _graph(&graph) {}
-
-      InArcIt& operator++() {
-        _graph->nextIn(*this);
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper2<InArcIt, BpGraph, Node> inArcs(const Node& u) const {
-      return LemonRangeWrapper2<InArcIt, BpGraph, Node>(*this, u);
-    }
-
-
-    class EdgeIt : public Parent::Edge {
-      const BpGraph* _graph;
-    public:
-
-      EdgeIt() { }
-
-      EdgeIt(Invalid i) : Edge(i) { }
-
-      explicit EdgeIt(const BpGraph& graph) : _graph(&graph) {
-        _graph->first(static_cast<Edge&>(*this));
-      }
-
-      EdgeIt(const BpGraph& graph, const Edge& edge) :
-        Edge(edge), _graph(&graph) { }
-
-      EdgeIt& operator++() {
-        _graph->next(*this);
-        return *this;
-      }
-
-    };
-
-    LemonRangeWrapper1<EdgeIt, BpGraph> edges() const {
-      return LemonRangeWrapper1<EdgeIt, BpGraph>(*this);
-    }
-
-
-    class IncEdgeIt : public Parent::Edge {
-      friend class BpGraphExtender;
-      const BpGraph* _graph;
-      bool _direction;
-    public:
-
-      IncEdgeIt() { }
-
-      IncEdgeIt(Invalid i) : Edge(i), _direction(false) { }
-
-      IncEdgeIt(const BpGraph& graph, const Node &node) : _graph(&graph) {
-        _graph->firstInc(*this, _direction, node);
-      }
-
-      IncEdgeIt(const BpGraph& graph, const Edge &edge, const Node &node)
-        : _graph(&graph), Edge(edge) {
-        _direction = (_graph->source(edge) == node);
-      }
-
-      IncEdgeIt& operator++() {
-        _graph->nextInc(*this, _direction);
-        return *this;
-      }
-    };
-
-    LemonRangeWrapper2<IncEdgeIt, BpGraph, Node> incEdges(const Node& u) const {
-      return LemonRangeWrapper2<IncEdgeIt, BpGraph, Node>(*this, u);
-    }
-
-
-    // \brief Base node of the iterator
-    //
-    // Returns the base node (ie. the source in this case) of the iterator
-    Node baseNode(const OutArcIt &arc) const {
-      return Parent::source(static_cast<const Arc&>(arc));
-    }
-    // \brief Running node of the iterator
-    //
-    // Returns the running node (ie. the target in this case) of the
-    // iterator
-    Node runningNode(const OutArcIt &arc) const {
-      return Parent::target(static_cast<const Arc&>(arc));
-    }
-
-    // \brief Base node of the iterator
-    //
-    // Returns the base node (ie. the target in this case) of the iterator
-    Node baseNode(const InArcIt &arc) const {
-      return Parent::target(static_cast<const Arc&>(arc));
-    }
-    // \brief Running node of the iterator
-    //
-    // Returns the running node (ie. the source in this case) of the
-    // iterator
-    Node runningNode(const InArcIt &arc) const {
-      return Parent::source(static_cast<const Arc&>(arc));
-    }
-
-    // Base node of the iterator
-    //
-    // Returns the base node of the iterator
-    Node baseNode(const IncEdgeIt &edge) const {
-      return edge._direction ? this->u(edge) : this->v(edge);
-    }
-    // Running node of the iterator
-    //
-    // Returns the running node of the iterator
-    Node runningNode(const IncEdgeIt &edge) const {
-      return edge._direction ? this->v(edge) : this->u(edge);
-    }
-
-    // Mappable extension
-
-    template <typename _Value>
-    class NodeMap
-      : public MapExtender<DefaultMap<BpGraph, Node, _Value> > {
-      typedef MapExtender<DefaultMap<BpGraph, Node, _Value> > Parent;
-
-    public:
-      explicit NodeMap(const BpGraph& bpgraph)
-        : Parent(bpgraph) {}
-      NodeMap(const BpGraph& bpgraph, const _Value& value)
-        : Parent(bpgraph, value) {}
-
-    private:
-      NodeMap& operator=(const NodeMap& cmap) {
-        return operator=<NodeMap>(cmap);
-      }
-
-      template <typename CMap>
-      NodeMap& operator=(const CMap& cmap) {
-        Parent::operator=(cmap);
-        return *this;
-      }
-
-    };
-
-    template <typename _Value>
-    class RedNodeMap
-      : public MapExtender<DefaultMap<BpGraph, RedNode, _Value> > {
-      typedef MapExtender<DefaultMap<BpGraph, RedNode, _Value> > Parent;
-
-    public:
-      explicit RedNodeMap(const BpGraph& bpgraph)
-        : Parent(bpgraph) {}
-      RedNodeMap(const BpGraph& bpgraph, const _Value& value)
-        : Parent(bpgraph, value) {}
-
-    private:
-      RedNodeMap& operator=(const RedNodeMap& cmap) {
-        return operator=<RedNodeMap>(cmap);
-      }
-
-      template <typename CMap>
-      RedNodeMap& operator=(const CMap& cmap) {
-        Parent::operator=(cmap);
-        return *this;
-      }
-
-    };
-
-    template <typename _Value>
-    class BlueNodeMap
-      : public MapExtender<DefaultMap<BpGraph, BlueNode, _Value> > {
-      typedef MapExtender<DefaultMap<BpGraph, BlueNode, _Value> > Parent;
-
-    public:
-      explicit BlueNodeMap(const BpGraph& bpgraph)
-        : Parent(bpgraph) {}
-      BlueNodeMap(const BpGraph& bpgraph, const _Value& value)
-        : Parent(bpgraph, value) {}
-
-    private:
-      BlueNodeMap& operator=(const BlueNodeMap& cmap) {
-        return operator=<BlueNodeMap>(cmap);
-      }
-
-      template <typename CMap>
-      BlueNodeMap& operator=(const CMap& cmap) {
-        Parent::operator=(cmap);
-        return *this;
-      }
-
-    };
-
-    template <typename _Value>
-    class ArcMap
-      : public MapExtender<DefaultMap<BpGraph, Arc, _Value> > {
-      typedef MapExtender<DefaultMap<BpGraph, Arc, _Value> > Parent;
-
-    public:
-      explicit ArcMap(const BpGraph& graph)
-        : Parent(graph) {}
-      ArcMap(const BpGraph& graph, const _Value& value)
-        : Parent(graph, value) {}
-
-    private:
-      ArcMap& operator=(const ArcMap& cmap) {
-        return operator=<ArcMap>(cmap);
-      }
-
-      template <typename CMap>
-      ArcMap& operator=(const CMap& cmap) {
-        Parent::operator=(cmap);
-        return *this;
-      }
-    };
-
-
-    template <typename _Value>
-    class EdgeMap
-      : public MapExtender<DefaultMap<BpGraph, Edge, _Value> > {
-      typedef MapExtender<DefaultMap<BpGraph, Edge, _Value> > Parent;
-
-    public:
-      explicit EdgeMap(const BpGraph& graph)
-        : Parent(graph) {}
-
-      EdgeMap(const BpGraph& graph, const _Value& value)
-        : Parent(graph, value) {}
-
-    private:
-      EdgeMap& operator=(const EdgeMap& cmap) {
-        return operator=<EdgeMap>(cmap);
-      }
-
-      template <typename CMap>
-      EdgeMap& operator=(const CMap& cmap) {
-        Parent::operator=(cmap);
-        return *this;
-      }
-
-    };
-
-    // Alteration extension
-
-    RedNode addRedNode() {
-      RedNode node = Parent::addRedNode();
-      notifier(RedNode()).add(node);
-      notifier(Node()).add(node);
-      return node;
-    }
-
-    BlueNode addBlueNode() {
-      BlueNode node = Parent::addBlueNode();
-      notifier(BlueNode()).add(node);
-      notifier(Node()).add(node);
-      return node;
-    }
-
-    Edge addEdge(const RedNode& from, const BlueNode& to) {
-      Edge edge = Parent::addEdge(from, to);
-      notifier(Edge()).add(edge);
-      std::vector<Arc> av;
-      av.push_back(Parent::direct(edge, true));
-      av.push_back(Parent::direct(edge, false));
-      notifier(Arc()).add(av);
-      return edge;
-    }
-
-    void clear() {
-      notifier(Arc()).clear();
-      notifier(Edge()).clear();
-      notifier(Node()).clear();
-      notifier(BlueNode()).clear();
-      notifier(RedNode()).clear();
-      Parent::clear();
-    }
-
-    template <typename BpGraph, typename NodeRefMap, typename EdgeRefMap>
-    void build(const BpGraph& graph, NodeRefMap& nodeRef,
-               EdgeRefMap& edgeRef) {
-      Parent::build(graph, nodeRef, edgeRef);
-      notifier(RedNode()).build();
-      notifier(BlueNode()).build();
-      notifier(Node()).build();
-      notifier(Edge()).build();
-      notifier(Arc()).build();
-    }
-
-    void erase(const Node& node) {
-      Arc arc;
-      Parent::firstOut(arc, node);
-      while (arc != INVALID ) {
-        erase(arc);
-        Parent::firstOut(arc, node);
-      }
-
-      Parent::firstIn(arc, node);
-      while (arc != INVALID ) {
-        erase(arc);
-        Parent::firstIn(arc, node);
-      }
-
-      if (Parent::red(node)) {
-        notifier(RedNode()).erase(this->asRedNodeUnsafe(node));
-      } else {
-        notifier(BlueNode()).erase(this->asBlueNodeUnsafe(node));
-      }
-
-      notifier(Node()).erase(node);
-      Parent::erase(node);
-    }
-
-    void erase(const Edge& edge) {
-      std::vector<Arc> av;
-      av.push_back(Parent::direct(edge, true));
-      av.push_back(Parent::direct(edge, false));
-      notifier(Arc()).erase(av);
-      notifier(Edge()).erase(edge);
-      Parent::erase(edge);
-    }
-
-    BpGraphExtender() {
-      red_node_notifier.setContainer(*this);
-      blue_node_notifier.setContainer(*this);
-      node_notifier.setContainer(*this);
-      arc_notifier.setContainer(*this);
-      edge_notifier.setContainer(*this);
-    }
-
-    ~BpGraphExtender() {
-      edge_notifier.clear();
-      arc_notifier.clear();
-      node_notifier.clear();
-      blue_node_notifier.clear();
-      red_node_notifier.clear();
-    }
-
-  };
-
 }
 
Index: lemon/bits/map_extender.h
===================================================================
--- lemon/bits/map_extender.h	(revision 1270)
+++ lemon/bits/map_extender.h	(revision 867)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/path_dump.h
===================================================================
--- lemon/bits/path_dump.h	(revision 1338)
+++ lemon/bits/path_dump.h	(revision 576)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -50,5 +50,5 @@
 
     bool empty() const {
-      return predMap[target] == INVALID;
+      return predMap[target] != INVALID;
     }
 
@@ -62,5 +62,5 @@
       }
 
-      operator typename Digraph::Arc() const {
+      operator const typename Digraph::Arc() const {
         return path->predMap[current];
       }
@@ -124,5 +124,5 @@
 
     bool empty() const {
-      return predMatrixMap(source, target) == INVALID;
+      return source != target;
     }
 
Index: lemon/bits/solver_bits.h
===================================================================
--- lemon/bits/solver_bits.h	(revision 1270)
+++ lemon/bits/solver_bits.h	(revision 566)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -45,5 +45,4 @@
       void clear() {
         first_item = -1;
-        last_item = -1;
         first_free_item = -1;
         items.clear();
Index: lemon/bits/traits.h
===================================================================
--- lemon/bits/traits.h	(revision 1270)
+++ lemon/bits/traits.h	(revision 663)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -149,86 +149,4 @@
         : Parent(_digraph, _value) {}
     };
-
-  };
-
-  template <typename GR, typename Enable = void>
-  struct RedNodeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename GR>
-  struct RedNodeNotifierIndicator<
-    GR,
-    typename enable_if<typename GR::RedNodeNotifier::Notifier, void>::type
-  > {
-    typedef typename GR::RedNodeNotifier Type;
-  };
-
-  template <typename GR>
-  class ItemSetTraits<GR, typename GR::RedNode> {
-  public:
-
-    typedef GR BpGraph;
-    typedef GR Graph;
-    typedef GR Digraph;
-
-    typedef typename GR::RedNode Item;
-    typedef typename GR::RedNodeIt ItemIt;
-
-    typedef typename RedNodeNotifierIndicator<GR>::Type ItemNotifier;
-
-    template <typename V>
-    class Map : public GR::template RedNodeMap<V> {
-      typedef typename GR::template RedNodeMap<V> Parent;
-
-    public:
-      typedef typename GR::template RedNodeMap<V> Type;
-      typedef typename Parent::Value Value;
-
-      Map(const GR& _bpgraph) : Parent(_bpgraph) {}
-      Map(const GR& _bpgraph, const Value& _value)
-        : Parent(_bpgraph, _value) {}
-
-     };
-
-  };
-
-  template <typename GR, typename Enable = void>
-  struct BlueNodeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename GR>
-  struct BlueNodeNotifierIndicator<
-    GR,
-    typename enable_if<typename GR::BlueNodeNotifier::Notifier, void>::type
-  > {
-    typedef typename GR::BlueNodeNotifier Type;
-  };
-
-  template <typename GR>
-  class ItemSetTraits<GR, typename GR::BlueNode> {
-  public:
-
-    typedef GR BpGraph;
-    typedef GR Graph;
-    typedef GR Digraph;
-
-    typedef typename GR::BlueNode Item;
-    typedef typename GR::BlueNodeIt ItemIt;
-
-    typedef typename BlueNodeNotifierIndicator<GR>::Type ItemNotifier;
-
-    template <typename V>
-    class Map : public GR::template BlueNodeMap<V> {
-      typedef typename GR::template BlueNodeMap<V> Parent;
-
-    public:
-      typedef typename GR::template BlueNodeMap<V> Type;
-      typedef typename Parent::Value Value;
-
-      Map(const GR& _bpgraph) : Parent(_bpgraph) {}
-      Map(const GR& _bpgraph, const Value& _value)
-        : Parent(_bpgraph, _value) {}
-
-     };
 
   };
Index: lemon/bits/windows.cc
===================================================================
--- lemon/bits/windows.cc	(revision 1341)
+++ lemon/bits/windows.cc	(revision 513)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -22,9 +22,5 @@
 #include<lemon/bits/windows.h>
 
-#if defined(LEMON_WIN32) && defined(__GNUC__)
-#pragma GCC diagnostic ignored "-Wold-style-cast"
-#endif
-
-#ifdef LEMON_WIN32
+#ifdef WIN32
 #ifndef WIN32_LEAN_AND_MEAN
 #define WIN32_LEAN_AND_MEAN
@@ -45,7 +41,5 @@
 #include <unistd.h>
 #include <ctime>
-#ifndef LEMON_WIN32
 #include <sys/times.h>
-#endif
 #include <sys/time.h>
 #endif
@@ -60,5 +54,5 @@
                          double &cutime, double &cstime)
     {
-#ifdef LEMON_WIN32
+#ifdef WIN32
       static const double ch = 4294967296.0e-7;
       static const double cl = 1.0e-7;
@@ -99,9 +93,9 @@
     {
       std::ostringstream os;
-#ifdef LEMON_WIN32
+#ifdef WIN32
       SYSTEMTIME time;
       GetSystemTime(&time);
       char buf1[11], buf2[9], buf3[5];
-      if (GetDateFormat(MY_LOCALE, 0, &time,
+	  if (GetDateFormat(MY_LOCALE, 0, &time,
                         ("ddd MMM dd"), buf1, 11) &&
           GetTimeFormat(MY_LOCALE, 0, &time,
@@ -125,5 +119,5 @@
     int getWinRndSeed()
     {
-#ifdef LEMON_WIN32
+#ifdef WIN32
       FILETIME time;
       GetSystemTimeAsFileTime(&time);
@@ -135,36 +129,4 @@
 #endif
     }
-
-    WinLock::WinLock() {
-#ifdef LEMON_WIN32
-      CRITICAL_SECTION *lock = new CRITICAL_SECTION;
-      InitializeCriticalSection(lock);
-      _repr = lock;
-#else
-      _repr = 0; //Just to avoid 'unused variable' warning with clang
-#endif
-    }
-
-    WinLock::~WinLock() {
-#ifdef LEMON_WIN32
-      CRITICAL_SECTION *lock = static_cast<CRITICAL_SECTION*>(_repr);
-      DeleteCriticalSection(lock);
-      delete lock;
-#endif
-    }
-
-    void WinLock::lock() {
-#ifdef LEMON_WIN32
-      CRITICAL_SECTION *lock = static_cast<CRITICAL_SECTION*>(_repr);
-      EnterCriticalSection(lock);
-#endif
-    }
-
-    void WinLock::unlock() {
-#ifdef LEMON_WIN32
-      CRITICAL_SECTION *lock = static_cast<CRITICAL_SECTION*>(_repr);
-      LeaveCriticalSection(lock);
-#endif
-    }
   }
 }
Index: lemon/bits/windows.h
===================================================================
--- lemon/bits/windows.h	(revision 1340)
+++ lemon/bits/windows.h	(revision 576)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -20,5 +20,4 @@
 #define LEMON_BITS_WINDOWS_H
 
-#include <lemon/config.h>
 #include <string>
 
@@ -30,14 +29,4 @@
     std::string getWinFormattedDate();
     int getWinRndSeed();
-
-    class WinLock {
-    public:
-      WinLock();
-      ~WinLock();
-      void lock();
-      void unlock();\
-    private:
-      void *_repr;
-    };
   }
 }
Index: lemon/bucket_heap.h
===================================================================
--- lemon/bucket_heap.h	(revision 956)
+++ lemon/bucket_heap.h	(revision 758)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2010
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -385,5 +385,5 @@
   ///
   /// Note that this implementation does not conform to the
-  /// \ref concepts::Heap "heap concept" due to the lack of some
+  /// \ref concepts::Heap "heap concept" due to the lack of some 
   /// functionality.
   ///
